package com.example.gestionstagesbackend.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import jakarta.persistence.*;
import java.util.List;
import java.util.stream.Collectors;

@Entity
public class Enterprise {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String name;
    private String address;

    @OneToMany(mappedBy = "enterprise", cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JsonIgnoreProperties({"enterprise"}) // Avoid infinite recursion
    private List<Stage> stages;

    /*@Transient // This field is not stored in the database
    public List<Candidacy> getCandidacies() {
        if (stages != null) {
            return stages.stream()
                    .flatMap(stage -> stage.getCandidacies().stream()) // Collect all candidacies
                    .collect(Collectors.toList());
        }
        return List.of(); // Return an empty list if no stages
    }*/

    public Enterprise() {}

    public Enterprise(String name, String address) {
        this.name = name;
        this.address = address;
    }

    public Long getId() { return id; }
    public String getName() { return name; }
    public String getAddress() { return address; }
    public List<Stage> getStages() { return stages; }

    public void setId(Long id) { this.id = id; }
    public void setName(String name) { this.name = name; }
    public void setAddress(String address) { this.address = address; }
    public void setStages(List<Stage> stages) { this.stages = stages; }
}
