package com.example.gestionstagesbackend.model;

import com.fasterxml.jackson.annotation.JsonBackReference;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.fasterxml.jackson.annotation.JsonProperty;
import jakarta.persistence.*;
import java.util.List;

@Entity
public class Stage {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @JsonProperty("name")
    private String name;
    private String description;

    @ManyToOne
    @JoinColumn(name = "enterprise_id", nullable = false)
    @JsonIgnoreProperties({"stages"}) // Prevents infinite loops but keeps enterprise data in JSON
    private Enterprise enterprise;


    @OneToMany(mappedBy = "stage", cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    //@JsonManagedReference
    private List<Candidacy> candidacies;


    public Stage() {}

    public Stage(String name, String description, Enterprise enterprise) {
        this.name = name;
        this.description = description;
        this.enterprise = enterprise;
    }

    public Stage(Long id, String name, String description, Enterprise enterprise, List<Candidacy> candidacies) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.enterprise = enterprise;
        this.candidacies = candidacies;
    }

    public Long getId() { return id; }
    public void setId(Long id) { this.id = id; }

    public String getName() { return name; }
    public void setName(String name) { this.name = name; }

    public String getDescription() { return description; }
    public void setDescription(String description) { this.description = description; }

    public Enterprise getEnterprise() { return enterprise; }
    public void setEnterprise(Enterprise enterprise) { this.enterprise = enterprise; }

    public List<Candidacy> getCandidacies() { return candidacies; }
    public void setCandidacies(List<Candidacy> candidacies) { this.candidacies = candidacies; }
}
