package com.example.gestionstagesbackend.model;

import jakarta.persistence.*;
import java.util.List;

@Entity
public class Student {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String firstname;
    private String lastname;

    @OneToMany(mappedBy = "student", cascade = CascadeType.ALL)
    private List<Candidacy> candidacies;

    @OneToOne
    @JoinColumn(name = "user_id", unique = true)
    private User user; // Ajout de la liaison avec User

    public Student() {}

    public Student(Long id, String firstname, String lastname, User user) {
        this.id = id;
        this.firstname = firstname;
        this.lastname = lastname;
        this.user = user;
    }

    public Long getId() { return id; }
    public void setId(Long id) { this.id = id; }

    public String getFirstname() { return firstname; }
    public void setFirstname(String firstname) { this.firstname = firstname; }

    public String getLastname() { return lastname; }
    public void setLastname(String lastname) { this.lastname = lastname; }

    public List<Candidacy> getCandidacies() { return candidacies; }
    public void setCandidacies(List<Candidacy> candidacies) { this.candidacies = candidacies; }

    public User getUser() { return user; }
    public void setUser(User user) { this.user = user; }
}
