package com.example.gestionstagesbackend.repositories;

import com.example.gestionstagesbackend.model.Candidacy;
import org.springframework.data.jpa.repository.EntityGraph;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

@Repository
public interface CandidacyRepository extends JpaRepository<Candidacy, Long> {
    @Query("SELECT c FROM Candidacy c JOIN FETCH c.student JOIN FETCH c.stage JOIN FETCH c.univSupervisor WHERE c.id = :id")
    Optional<Candidacy> findByIdWithRelations(@Param("id") Long id);

    @Query("SELECT c FROM Candidacy c JOIN FETCH c.student JOIN FETCH c.stage JOIN FETCH c.univSupervisor WHERE c.student.id = :studentId")
    List<Candidacy> findByStudentId(@Param("studentId") Long studentId);
}

