package com.example.gestionstagesbackend.repositories;

import com.example.gestionstagesbackend.model.Stage;
import org.springframework.data.jpa.repository.EntityGraph;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.Optional;

@Repository
public interface StageRepository extends JpaRepository<Stage, Long> {

    @EntityGraph(attributePaths = {"enterprise"}) // Ensures Enterprise is fetched
    Optional<Stage> findById(Long id);
    @Query("SELECT s FROM Stage s LEFT JOIN FETCH s.enterprise WHERE s.id = :id")
    Optional<Stage> findByIdWithEnterprise(@Param("id") Long id);

}
