package com.example.gestionstagesbackend.repositories;

import com.example.gestionstagesbackend.model.Student;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface StudentRepository extends JpaRepository<Student, Long> {
    @Query("SELECT s FROM Student s WHERE s.user.id IN (SELECT u.id FROM User u WHERE :role MEMBER OF u.roles)")
    List<Student> findStudentsByRole(@Param("role") String role);
    Optional<Student> findByFirstnameAndLastname(String firstname, String lastname);
}
