package com.example.gestionstagesbackend.services;

import com.example.gestionstagesbackend.model.Candidacy;
import com.example.gestionstagesbackend.repositories.CandidacyRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import java.util.List;
import java.util.Optional;

@Service
public class CandidacyService {
    private final CandidacyRepository candidacyRepository;

    public CandidacyService(CandidacyRepository candidacyRepository) {
        this.candidacyRepository = candidacyRepository;
    }

    public List<Candidacy> getAllCandidacies() {
        return candidacyRepository.findAll();
    }

    @Transactional(readOnly = true)
    public Optional<Candidacy> getCandidacyById(Long id) {
        return candidacyRepository.findByIdWithRelations(id);
    }

    public Candidacy saveCandidacy(Candidacy candidacy) {
        return candidacyRepository.save(candidacy);
    }

    public void deleteCandidacy(Long id) {
        candidacyRepository.deleteById(id);
    }

    public List<Candidacy> getCandidaciesByStudentId(Long studentId) {
        return candidacyRepository.findByStudentId(studentId);
    }
    public boolean existsById(Long id) {
        return candidacyRepository.existsById(id);
    }

}
