package com.example.gestionstagesbackend.services;

import com.example.gestionstagesbackend.model.Stage;
import com.example.gestionstagesbackend.repositories.StageRepository;
import org.hibernate.Hibernate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Optional;

@Service
public class StageService {
    private final StageRepository stageRepository;

    public StageService(StageRepository stageRepository) {
        this.stageRepository = stageRepository;
    }

    public Stage saveStage(Stage stage) {
        return stageRepository.save(stage);
    }

    public List<Stage> getAllStages() {
        return stageRepository.findAll();
    }

    public Optional<Stage> getStageById(Long id) {
        return stageRepository.findByIdWithEnterprise(id);
    }


    public void deleteStage(Long id) {
        stageRepository.deleteById(id);
    }

}
