package com.example.gestionstagesbackend.services;

import com.example.gestionstagesbackend.model.UnivSupervisor;
import com.example.gestionstagesbackend.repositories.UnivSupervisorRepository;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class UnivSupervisorService {
    private final UnivSupervisorRepository univSupervisorRepository;

    public UnivSupervisorService(UnivSupervisorRepository univSupervisorRepository) {
        this.univSupervisorRepository = univSupervisorRepository;
    }

    public List<UnivSupervisor> getAllUnivSupervisors() {
        return univSupervisorRepository.findAll();
    }

    public Optional<UnivSupervisor> getUnivSupervisorById(Long id) {
        return univSupervisorRepository.findById(id);
    }

    public UnivSupervisor saveUnivSupervisor(UnivSupervisor univSupervisor) {
        return univSupervisorRepository.save(univSupervisor);
    }

    public void deleteUnivSupervisor(Long id) {
        univSupervisorRepository.deleteById(id);
    }
}
